-- Welcome to the sewers of barrel gross town.

Hooks:PostHook(WeaponFactoryManager, "clbk_part_unit_loaded", "GlugerLocc_VisibilityFuckery", function(self, task_data, status, u_type, u_name)
	for part_id, part in pairs(task_data.parts) do
		if alive(part.unit) then
			self:_set_visibility(part_id, part, task_data.npc, task_data.blueprint)
		end
	end
end)

function WeaponFactoryManager:_set_visibility(part_id, part, npc, blueprint)
	local visibility = self:_visibility_from_part_id(part_id)

	if visibility then
		for _, group in ipairs(visibility) do
			if not group.condition or group:condition(part, npc, blueprint) then
				for object_name, visible in pairs(group.objects) do
					local object = part.unit:get_object(Idstring(object_name))

					if object then
						object:set_visibility(visible)
					end
				end
			end
		end
	end
end