Hooks:PostHook( WeaponTweakData, "init", "GlugerLoccConversionKits_WeaponTweakData", function(self)
	--[[
		   _____ _     _    _  _____ ______ _____  
		  / ____| |   | |  | |/ ____|  ____|  __ \ 
		 | |  __| |   | |  | | |  __| |__  | |__) |
		 | | |_ | |   | |  | | | |_ |  __| |  _  / 
		 | |__| | |___| |__| | |__| | |____| | \ \ 
		  \_____|______\____/ \_____|______|_|  \_\

	]]

	local guns = {
		"glock_17",
		"x_g17"
	}

	for index, gun in pairs(guns) do
		self:SetupAttachmentPoint( gun, {
			name = "a_gluger",
			base_a_obj = "a_b",
			position = Vector3( 0, 3.5, -2.1 ),
			rotation = RotationCAP( 0, 0, 0 ),
			part_attach_data = {
				{"wpn_upg_b_gluger_slide_invis"},
				"g_slide_lod0"
			}
		})
		self:SetupAttachmentPoint( gun, {
			name = "a_rds_gluger",
			position = Vector3( 0, 3, 1 ),
			rotation = RotationCAP( 0, 0, 0 ),
			part_attach_data = {
				{"wpn_upg_b_gluger_slide"},
				"g_barrel_base"
			}
		})
	end

	local guns = {
		"g22c",
		"x_g22c"
	}

	for index, gun in pairs(guns) do
		self:SetupAttachmentPoint( gun, {
			name = "a_gluger",
			base_a_obj = "a_b",
			position = Vector3( 0, 3.5, -2.1 ),
			rotation = RotationCAP( 0, 0, 0 ),
			part_attach_data = {
				{"wpn_upg_b_gluger_slide_invis"},
				"g_slide_lod0"
			}
		})
		self:SetupAttachmentPoint( gun, {
			name = "a_rds_gluger",
			position = Vector3( 0, 3, 1 ),
			rotation = RotationCAP( 0, 0, 0 ),
			part_attach_data = {
				{"wpn_upg_b_gluger_slide"},
				"g_barrel_base"
			}
		})
	end

	local guns = {
		"g26",
		"jowi"
	}

	for index, gun in pairs(guns) do
		self:SetupAttachmentPoint( gun, {
			name = "a_gluger",
			base_a_obj = "a_b",
			position = Vector3( 0, 6.3, -0.4 ),
			rotation = RotationCAP( 0, 0, 0 ),
			part_attach_data = {
				{"wpn_upg_b_gluger_slide_invis"},
				"g_slide_lod0"
			}
		})
		self:SetupAttachmentPoint( gun, {
			name = "a_rds_gluger",
			position = Vector3( 0, 3, 1 ),
			rotation = RotationCAP( 0, 0, 0 ),
			part_attach_data = {
				{"wpn_upg_b_gluger_slide"},
				"g_barrel_base"
			}
		})
	end

	local guns = {
		"glock_18c",
		"x_g18c"
	}

	for index, gun in pairs(guns) do
		self:SetupAttachmentPoint( gun, {
			name = "a_gluger",
			base_a_obj = "a_b",
			position = Vector3( 0, -7.5, -0.5 ),
			rotation = RotationCAP( 0, 0, 0 ),
			part_attach_data = {
				{"wpn_upg_b_gluger_slide_invis"},
				"g_slide_lod0"
			}
		})
		self:SetupAttachmentPoint( gun, {
			name = "a_rds_gluger",
			position = Vector3( 0, 3, 1 ),
			rotation = RotationCAP( 0, 0, 0 ),
			part_attach_data = {
				{"wpn_upg_b_gluger_slide"},
				"g_barrel_base"
			}
		})
	end

	--[[
		  _      ____   _____ _____ 
		 | |    / __ \ / ____/ ____|
		 | |   | |  | | |   | |     
		 | |   | |  | | |   | |     
		 | |___| |__| | |___| |____ 
		 |______\____/ \_____\_____|

	]]

	local guns = {
		"breech",
		"x_breech"
	}

	for index, gun in pairs(guns) do
		self:SetupAttachmentPoint( gun, {
			name = "a_locc",
			base_a_obj = "a_dh",
			position = Vector3( 0, 1.1, 2.3 ),
			rotation = RotationCAP( 0, 0, 0 )
		})
		self:SetupAttachmentPoint( gun, {
			name = "a_locc_g26",
			base_a_obj = "a_dh",
			position = Vector3( 0, -0.8, 0.6 ),
			rotation = RotationCAP( 0, 0, 0 )
		})
		self:SetupAttachmentPoint( gun, {
			name = "a_locc_g18c",
			base_a_obj = "a_b",
			position = Vector3( 0, 8.8, 0.8 ),
			rotation = RotationCAP( 0, 0, 0 )
		})

		self:SetupAttachmentPoint( gun, {
			name = "a_locc_barrel",
			base_a_obj = "a_body",
			position = Vector3( 0, 3.2, 0.6 ),
			rotation = RotationCAP( 0, 0, 0 )
		})
		self:SetupAttachmentPoint( gun, {
			name = "a_locc_g18c_barrel",
			base_a_obj = "a_body",
			position = Vector3( 0, 3.7, 0.85 ),
			rotation = RotationCAP( 0, 0, 0 )
		})
	end
end)